#!/usr/bin/perl
# 
# library - lock 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.04;
	# ver 0.00 [2003/09/20] 
	# ver 0.01 [2003/10/07] С褦
	# ver 0.02 [2003/12/10] ॢȡԲꤵƤʤХ
	# ver 0.03 [2004/07/21] ॢȻ֤ѹ
	# ver 0.04 [2004/09/07] ϥåΥˡ㴳ѹ
}

# original script by OHZAKI Hiroki
# [title] Perl memo
#   [uri] http://www.din.or.jp/~ohzaki/perl.htm
sub sblock_lock { # å
	my %lfh = ('dir' => $gLock_Dir, 'basename' => $gLockFile, 'timeout' => 20, 'trytime' => 10, @_);
	$lfh{'path'} = $lfh{'dir'} . $lfh{'basename'};
	for (my $i = 0; $i < $lfh{'trytime'}; $i++, sleep 1) {
		return \%lfh if (rename($lfh{'path'}, $lfh{'current'} = $lfh{'path'} . time));
	}
	opendir(LOCKDIR, $lfh{'dir'});
	my @filelist = readdir(LOCKDIR);
	closedir(LOCKDIR);
	foreach (@filelist) {
		if (/^$lfh{'basename'}(\d+)/) {
			return \%lfh if (time - $1 > $lfh{'timeout'} and
			rename($lfh{'dir'} . $_, $lfh{'current'} = $lfh{'path'} . time));
			last;
		}
	}
	undef;
}

sub sblock_unlock { # å
	rename($_[0]->{'current'}, $_[0]->{'path'});
}
1;
